#!/usr/bin/perl
use strict;
use warnings;

use strict;
use warnings;

my @leaves_treeTMP = <DATA>;
my $ref_leaves_tree = &readJASON(\@leaves_treeTMP);
my @leaves_tree  = @$ref_leaves_tree;

my $infile = "seq_fasta.txt";
open(INFILE,"$infile") or die "$!";
my @inFileCont = <INFILE>;
close INFILE;
my ($ref_fasHash,$ref_nameArray, $sequenceLength) = &fastaReadHash(\@inFileCont);

foreach my $leaf (@leaves_tree) {
  my $leaf1 = ">".$leaf;
  print "$leaf1\n";
  print "$$ref_fasHash{$leaf1}\n";
}
exit;

foreach my $name (@$ref_nameArray){
  print "$name\n";
  print "$$ref_fasHash{$name}\n";
}

exit;

sub readJASON
{
  my ($ref_jason_lines) = @_;
  my @jason_lines = @$ref_jason_lines;
  my @names = ();
  foreach my $line (@jason_lines) {
    if($line =~ /"name": "([^"]+)",/){
      my $name = $1;
      #print "$name\n";
      push(@names, $name);
    }
  }
  return (\@names);
}

sub fastaReadHash
{
  my $name = "";
  my $sequence = "";
  my $sequenceLength = "";
  my $flag = 0;
  my @nameArraySR = ( );
  my %fasHashSR = ( );

  my ($inFileContSR) = @_;

  foreach my $inFileLine (@$inFileContSR) {
    chomp($inFileLine);
    if($inFileLine =~ /^>/){  
      if($flag == 0){$name = $inFileLine;
        $flag = 1;  
      } else {
        $fasHashSR{$name} = $sequence;  
        push(@nameArraySR,$name);
        $name = "$inFileLine";
        $sequence = "";
      }
    } else {
      $sequence .= $inFileLine; 
    }
  }
  $fasHashSR{$name} = $sequence;
  $sequenceLength = length($sequence);
  push(@nameArraySR,$name);

  return (\%fasHashSR,\@nameArraySR,\$sequenceLength);
}

__END__
{
	"root": {
		"children": [
			{
				"name": "Scca",
				"length": 3.0,
				"height": 0.0
			},
			{
				"children": [
					{
						"children": [
							{
								"name": "Poop",
								"length": 1.0,
								"height": 0.0
							},
							{
								"name": "Pose",
								"length": 1.0,
								"height": 0.0
							}
						],
						"length": 1.0,
						"height": 1.0
					},
					{
						"children": [
							{
								"name": "Lame",
								"length": 1.0,
								"height": 0.0
							},
							{
								"name": "Lach",
								"length": 1.0,
								"height": 0.0
							}
						],
						"length": 1.0,
						"height": 1.0
					}
				],
				"length": 1.0,
				"height": 2.0
			}
		],
		"height": 3.0
	},

	"origin":"2013.34520547945",
}
